>From a5373b4563d4c71ac9e882300bfccdc3f8f40819 Mon Sep 17 00:00:00 2001
From: Abhishek Koneru <akoneru@redhat.com>
Date: Thu, 16 May 2013 10:40:12 -0400
Subject: [PATCH] Do not use sys.exit() after an error.

Raise an exception on error so that it can be handled by the
caller.

Ticket #562
---
 base/server/src/engine/pkihelper.py         | 1282 ++++++++++++++-------------
 base/server/src/engine/pkimanifest.py       |    4 +-
 base/server/src/engine/pkiparser.py         |    6 +-
 base/server/src/pkispawn                    |    1 +
 base/server/src/scriptlets/configuration.py |    2 +-
 5 files changed, 670 insertions(+), 625 deletions(-)

diff --git a/base/server/src/engine/pkihelper.py b/base/server/src/engine/pkihelper.py
index e7735d8d37260d564d148842672bc31e6b42c638..df36583079cea16a0d199de3e0007bc7a1a12e12 100644
--- a/base/server/src/engine/pkihelper.py
+++ b/base/server/src/engine/pkihelper.py
@@ -59,7 +59,7 @@ import pki.client
 import pki.system
 
 # PKI Deployment Helper Functions
-def pki_copytree(src, dst, symlinks=False, ignore=None):
+def pki_copytree(src, dst, symlinks = False, ignore = None):
     """Recursively copy a directory tree using copy2().
 
     PATCH:  This code was copied from 'shutil.py' and patched to
@@ -138,46 +138,46 @@ class identity:
             pki_gid = getgrnam(pki_group)[2]
             # Yes, group 'pki_group' exists!
             config.pki_log.info(log.PKIHELPER_GROUP_ADD_2, pki_group, pki_gid,
-                                extra=config.PKI_INDENTATION_LEVEL_2)
+                                extra = config.PKI_INDENTATION_LEVEL_2)
         except KeyError as exc:
             # No, group 'pki_group' does not exist!
             config.pki_log.debug(log.PKIHELPER_GROUP_ADD_KEYERROR_1, exc,
-                                 extra=config.PKI_INDENTATION_LEVEL_2)
+                                 extra = config.PKI_INDENTATION_LEVEL_2)
             try:
                 # Is the default well-known GID already defined?
                 group = getgrgid(config.PKI_DEPLOYMENT_DEFAULT_GID)[0]
                 # Yes, the default well-known GID exists!
                 config.pki_log.info(log.PKIHELPER_GROUP_ADD_DEFAULT_2,
                                     group, config.PKI_DEPLOYMENT_DEFAULT_GID,
-                                    extra=config.PKI_INDENTATION_LEVEL_2)
+                                    extra = config.PKI_INDENTATION_LEVEL_2)
                 # Attempt to create 'pki_group' using a random GID.
-                command = "/usr/sbin/groupadd" + " " +\
-                          pki_group + " " +\
+                command = "/usr/sbin/groupadd" + " " + \
+                          pki_group + " " + \
                           "> /dev/null 2>&1"
             except KeyError as exc:
                 # No, the default well-known GID does not exist!
                 config.pki_log.debug(log.PKIHELPER_GROUP_ADD_GID_KEYERROR_1,
-                                     exc, extra=config.PKI_INDENTATION_LEVEL_2)
+                                     exc, extra = config.PKI_INDENTATION_LEVEL_2)
                 # Is the specified 'pki_group' the default well-known group?
                 if pki_group == config.PKI_DEPLOYMENT_DEFAULT_GROUP:
                     # Yes, attempt to create the default well-known group
                     # using the default well-known GID.
-                    command = "/usr/sbin/groupadd" + " " +\
-                              "-g" + " " +\
-                              str(config.PKI_DEPLOYMENT_DEFAULT_GID) + " " +\
-                              "-r" + " " +\
-                              pki_group + " " +\
+                    command = "/usr/sbin/groupadd" + " " + \
+                              "-g" + " " + \
+                              str(config.PKI_DEPLOYMENT_DEFAULT_GID) + " " + \
+                              "-r" + " " + \
+                              pki_group + " " + \
                               "> /dev/null 2>&1"
                 else:
                     # No, attempt to create 'pki_group' using a random GID.
-                    command = "/usr/sbin/groupadd" + " " +\
-                              pki_group + " " +\
+                    command = "/usr/sbin/groupadd" + " " + \
+                              pki_group + " " + \
                               "> /dev/null 2>&1"
             # Execute this "groupadd" command.
-            subprocess.call(command, shell=True)
+            subprocess.call(command, shell = True)
         except subprocess.CalledProcessError as exc:
             config.pki_log.error(log.PKI_SUBPROCESS_ERROR_1, exc,
-                                 extra=config.PKI_INDENTATION_LEVEL_2)
+                                 extra = config.PKI_INDENTATION_LEVEL_2)
             raise
         return
 
@@ -188,71 +188,71 @@ class identity:
             pki_uid = getpwnam(pki_user)[2]
             # Yes, user 'pki_user' exists!
             config.pki_log.info(log.PKIHELPER_USER_ADD_2, pki_user, pki_uid,
-                                extra=config.PKI_INDENTATION_LEVEL_2)
+                                extra = config.PKI_INDENTATION_LEVEL_2)
             # NOTE:  For now, never check validity of specified 'pki_group'!
         except KeyError as exc:
             # No, user 'pki_user' does not exist!
             config.pki_log.debug(log.PKIHELPER_USER_ADD_KEYERROR_1, exc,
-                                 extra=config.PKI_INDENTATION_LEVEL_2)
+                                 extra = config.PKI_INDENTATION_LEVEL_2)
             try:
                 # Is the default well-known UID already defined?
                 user = getpwuid(config.PKI_DEPLOYMENT_DEFAULT_UID)[0]
                 # Yes, the default well-known UID exists!
                 config.pki_log.info(log.PKIHELPER_USER_ADD_DEFAULT_2,
                                     user, config.PKI_DEPLOYMENT_DEFAULT_UID,
-                                    extra=config.PKI_INDENTATION_LEVEL_2)
+                                    extra = config.PKI_INDENTATION_LEVEL_2)
                 # Attempt to create 'pki_user' using a random UID.
-                command = "/usr/sbin/useradd" + " " +\
-                          "-g" + " " +\
-                          pki_group + " " +\
-                          "-d" + " " +\
-                          config.PKI_DEPLOYMENT_SOURCE_ROOT + " " +\
-                          "-s" + " " +\
-                          config.PKI_DEPLOYMENT_DEFAULT_SHELL + " " +\
-                          "-c" + " " +\
-                          config.PKI_DEPLOYMENT_DEFAULT_COMMENT + " " +\
-                          pki_user + " " +\
+                command = "/usr/sbin/useradd" + " " + \
+                          "-g" + " " + \
+                          pki_group + " " + \
+                          "-d" + " " + \
+                          config.PKI_DEPLOYMENT_SOURCE_ROOT + " " + \
+                          "-s" + " " + \
+                          config.PKI_DEPLOYMENT_DEFAULT_SHELL + " " + \
+                          "-c" + " " + \
+                          config.PKI_DEPLOYMENT_DEFAULT_COMMENT + " " + \
+                          pki_user + " " + \
                           "> /dev/null 2>&1"
             except KeyError as exc:
                 # No, the default well-known UID does not exist!
                 config.pki_log.debug(log.PKIHELPER_USER_ADD_UID_KEYERROR_1,
-                                     exc, extra=config.PKI_INDENTATION_LEVEL_2)
+                                     exc, extra = config.PKI_INDENTATION_LEVEL_2)
                 # Is the specified 'pki_user' the default well-known user?
                 if pki_user == config.PKI_DEPLOYMENT_DEFAULT_USER:
                     # Yes, attempt to create the default well-known user
                     # using the default well-known UID.
-                    command = "/usr/sbin/useradd" + " " +\
-                              "-g" + " " +\
-                              pki_group + " " +\
-                              "-d" + " " +\
-                              config.PKI_DEPLOYMENT_SOURCE_ROOT + " " +\
-                              "-s" + " " +\
-                              config.PKI_DEPLOYMENT_DEFAULT_SHELL + " " +\
-                              "-c" + " " +\
-                              config.PKI_DEPLOYMENT_DEFAULT_COMMENT + " " +\
-                              "-u" + " " +\
-                              str(config.PKI_DEPLOYMENT_DEFAULT_UID) + " " +\
-                              "-r" + " " +\
-                              pki_user + " " +\
+                    command = "/usr/sbin/useradd" + " " + \
+                              "-g" + " " + \
+                              pki_group + " " + \
+                              "-d" + " " + \
+                              config.PKI_DEPLOYMENT_SOURCE_ROOT + " " + \
+                              "-s" + " " + \
+                              config.PKI_DEPLOYMENT_DEFAULT_SHELL + " " + \
+                              "-c" + " " + \
+                              config.PKI_DEPLOYMENT_DEFAULT_COMMENT + " " + \
+                              "-u" + " " + \
+                              str(config.PKI_DEPLOYMENT_DEFAULT_UID) + " " + \
+                              "-r" + " " + \
+                              pki_user + " " + \
                               "> /dev/null 2>&1"
                 else:
                     # No, attempt to create 'pki_user' using a random UID.
-                    command = "/usr/sbin/useradd" + " " +\
-                              "-g" + " " +\
-                              pki_group + " " +\
-                              "-d" + " " +\
-                              config.PKI_DEPLOYMENT_SOURCE_ROOT + " " +\
-                              "-s" + " " +\
-                              config.PKI_DEPLOYMENT_DEFAULT_SHELL + " " +\
-                              "-c" + " " +\
-                              config.PKI_DEPLOYMENT_DEFAULT_COMMENT + " " +\
-                              pki_user + " " +\
+                    command = "/usr/sbin/useradd" + " " + \
+                              "-g" + " " + \
+                              pki_group + " " + \
+                              "-d" + " " + \
+                              config.PKI_DEPLOYMENT_SOURCE_ROOT + " " + \
+                              "-s" + " " + \
+                              config.PKI_DEPLOYMENT_DEFAULT_SHELL + " " + \
+                              "-c" + " " + \
+                              config.PKI_DEPLOYMENT_DEFAULT_COMMENT + " " + \
+                              pki_user + " " + \
                               "> /dev/null 2>&1"
             # Execute this "useradd" command.
-            subprocess.call(command, shell=True)
+            subprocess.call(command, shell = True)
         except subprocess.CalledProcessError as exc:
             config.pki_log.error(log.PKI_SUBPROCESS_ERROR_1, exc,
-                                 extra=config.PKI_INDENTATION_LEVEL_2)
+                                 extra = config.PKI_INDENTATION_LEVEL_2)
             raise
         return
 
@@ -261,54 +261,54 @@ class identity:
         self.__add_uid(pki_user, pki_group)
         return
 
-    def get_uid(self, critical_failure=True):
+    def get_uid(self, critical_failure = True):
         try:
             pki_uid = master['pki_uid']
         except KeyError as exc:
             config.pki_log.error(log.PKI_KEYERROR_1, exc,
-                                 extra=config.PKI_INDENTATION_LEVEL_2)
+                                 extra = config.PKI_INDENTATION_LEVEL_2)
             if critical_failure == True:
                 raise
         return pki_uid
 
-    def get_gid(self, critical_failure=True):
+    def get_gid(self, critical_failure = True):
         try:
             pki_gid = master['pki_gid']
         except KeyError as exc:
             config.pki_log.error(log.PKI_KEYERROR_1, exc,
-                                 extra=config.PKI_INDENTATION_LEVEL_2)
+                                 extra = config.PKI_INDENTATION_LEVEL_2)
             if critical_failure == True:
                 raise
         return pki_gid
 
-    def set_uid(self, name, critical_failure=True):
+    def set_uid(self, name, critical_failure = True):
         try:
             config.pki_log.debug(log.PKIHELPER_USER_1, name,
-                                 extra=config.PKI_INDENTATION_LEVEL_2)
+                                 extra = config.PKI_INDENTATION_LEVEL_2)
             # id -u <name>
             pki_uid = getpwnam(name)[2]
-            master['pki_uid']=pki_uid
+            master['pki_uid'] = pki_uid
             config.pki_log.debug(log.PKIHELPER_UID_2, name, pki_uid,
-                                 extra=config.PKI_INDENTATION_LEVEL_3)
+                                 extra = config.PKI_INDENTATION_LEVEL_3)
         except KeyError as exc:
             config.pki_log.error(log.PKI_KEYERROR_1, exc,
-                                 extra=config.PKI_INDENTATION_LEVEL_2)
+                                 extra = config.PKI_INDENTATION_LEVEL_2)
             if critical_failure == True:
                 raise
         return pki_uid
 
-    def set_gid(self, name, critical_failure=True):
+    def set_gid(self, name, critical_failure = True):
         try:
             config.pki_log.debug(log.PKIHELPER_GROUP_1, name,
-                                 extra=config.PKI_INDENTATION_LEVEL_2)
+                                 extra = config.PKI_INDENTATION_LEVEL_2)
             # id -g <name>
             pki_gid = getgrnam(name)[2]
-            master['pki_gid']=pki_gid
+            master['pki_gid'] = pki_gid
             config.pki_log.debug(log.PKIHELPER_GID_2, name, pki_gid,
-                                 extra=config.PKI_INDENTATION_LEVEL_3)
+                                 extra = config.PKI_INDENTATION_LEVEL_3)
         except KeyError as exc:
             config.pki_log.error(log.PKI_KEYERROR_1, exc,
-                                 extra=config.PKI_INDENTATION_LEVEL_2)
+                                 extra = config.PKI_INDENTATION_LEVEL_2)
             if critical_failure == True:
                 raise
         return pki_gid
@@ -327,8 +327,9 @@ class namespace:
                     log.PKIHELPER_NAMESPACE_COLLISION_2,
                     master['pki_instance_name'],
                     master['pki_instance_path'],
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
+                raise Exception(log.PKIHELPER_NAMESPACE_COLLISION_2 % (master['pki_instance_name'],
+                                                                    master['pki_instance_path']))
         else:
             if os.path.exists(master['pki_target_tomcat_conf_instance_id']):
                 # Top-Level "/etc/sysconfig" path collision
@@ -336,24 +337,27 @@ class namespace:
                     log.PKIHELPER_NAMESPACE_COLLISION_2,
                     master['pki_instance_name'],
                     master['pki_target_tomcat_conf_instance_id'],
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
+                raise Exception(log.PKIHELPER_NAMESPACE_COLLISION_2 % (master['pki_instance_name'],
+                                                                      master['pki_target_tomcat_conf_instance_id']))
             if os.path.exists(master['pki_cgroup_systemd_service']):
                 # Systemd cgroup path collision
                 config.pki_log.error(
                     log.PKIHELPER_NAMESPACE_COLLISION_2,
                     master['pki_instance_name'],
                     master['pki_cgroup_systemd_service_path'],
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
+                raise Exception(log.PKIHELPER_NAMESPACE_COLLISION_2 % (master['pki_instance_name'],
+                                                                      master['pki_cgroup_systemd_service_path']))
             if os.path.exists(master['pki_cgroup_cpu_systemd_service']):
                 # Systemd cgroup CPU path collision
                 config.pki_log.error(
                     log.PKIHELPER_NAMESPACE_COLLISION_2,
                     master['pki_instance_name'],
                     master['pki_cgroup_cpu_systemd_service_path'],
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
+                raise Exception(log.PKIHELPER_NAMESPACE_COLLISION_2 % (master['pki_instance_name'],
+                                                                      master['pki_cgroup_cpu_systemd_service_path']))
         if os.path.exists(master['pki_instance_log_path']) and\
            os.path.exists(master['pki_subsystem_log_path']):
             # Top-Level PKI log path collision
@@ -361,8 +365,9 @@ class namespace:
                 log.PKIHELPER_NAMESPACE_COLLISION_2,
                 master['pki_instance_name'],
                 master['pki_instance_log_path'],
-                extra=config.PKI_INDENTATION_LEVEL_2)
-            sys.exit(1)
+                extra = config.PKI_INDENTATION_LEVEL_2)
+            raise Exception(log.PKIHELPER_NAMESPACE_COLLISION_2 % (master['pki_instance_name'],
+                                                                  master['pki_instance_log_path']))
         if os.path.exists(master['pki_instance_configuration_path']) and\
            os.path.exists(master['pki_subsystem_configuration_path']):
             # Top-Level PKI configuration path collision
@@ -370,8 +375,9 @@ class namespace:
                 log.PKIHELPER_NAMESPACE_COLLISION_2,
                 master['pki_instance_name'],
                 master['pki_instance_configuration_path'],
-                extra=config.PKI_INDENTATION_LEVEL_2)
-            sys.exit(1)
+                extra = config.PKI_INDENTATION_LEVEL_2)
+            raise Exception(log.PKIHELPER_NAMESPACE_COLLISION_2 % (master['pki_instance_name'],
+                                                                  master['pki_instance_configuration_path']))
         if os.path.exists(master['pki_instance_registry_path']) and\
            os.path.exists(master['pki_subsystem_registry_path']):
             # Top-Level PKI registry path collision
@@ -379,8 +385,9 @@ class namespace:
                 log.PKIHELPER_NAMESPACE_COLLISION_2,
                 master['pki_instance_name'],
                 master['pki_instance_registry_path'],
-                extra=config.PKI_INDENTATION_LEVEL_2)
-            sys.exit(1)
+                extra = config.PKI_INDENTATION_LEVEL_2)
+            raise Exception(log.PKIHELPER_NAMESPACE_COLLISION_2 % (master['pki_instance_name'],
+                                                                  master['pki_instance_registry_path']))
         # Run simple checks for reserved name namespace collisions
         if master['pki_instance_name'] in config.PKI_BASE_RESERVED_NAMES:
             # Top-Level PKI base path reserved name collision
@@ -388,8 +395,9 @@ class namespace:
                 log.PKIHELPER_NAMESPACE_RESERVED_NAME_2,
                 master['pki_instance_name'],
                 master['pki_instance_path'],
-                extra=config.PKI_INDENTATION_LEVEL_2)
-            sys.exit(1)
+                extra = config.PKI_INDENTATION_LEVEL_2)
+            raise Exception(log.PKIHELPER_NAMESPACE_RESERVED_NAME_2 % (master['pki_instance_name'],
+                                                                      master['pki_instance_path']))
         # No need to check for reserved name under Top-Level PKI log path
         if master['pki_instance_name'] in config.PKI_CONFIGURATION_RESERVED_NAMES:
             # Top-Level PKI configuration path reserved name collision
@@ -397,8 +405,9 @@ class namespace:
                 log.PKIHELPER_NAMESPACE_RESERVED_NAME_2,
                 master['pki_instance_name'],
                 master['pki_instance_configuration_path'],
-                extra=config.PKI_INDENTATION_LEVEL_2)
-            sys.exit(1)
+                extra = config.PKI_INDENTATION_LEVEL_2)
+            raise Exception(log.PKIHELPER_NAMESPACE_RESERVED_NAME_2 % (master['pki_instance_name'],
+                                                                      master['pki_instance_configuration_path']))
         if master['pki_subsystem'] in config.PKI_APACHE_SUBSYSTEMS:
             # Top-Level Apache PKI registry path reserved name collision
             if master['pki_instance_name'] in\
@@ -407,8 +416,9 @@ class namespace:
                     log.PKIHELPER_NAMESPACE_RESERVED_NAME_2,
                     master['pki_instance_name'],
                     master['pki_instance_registry_path'],
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
+                raise Exception(log.PKIHELPER_NAMESPACE_RESERVED_NAME_2 % (master['pki_instance_name'],
+                                                                          master['pki_instance_registry_path']))
         elif master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
             # Top-Level Tomcat PKI registry path reserved name collision
             if master['pki_instance_name'] in\
@@ -417,8 +427,9 @@ class namespace:
                     log.PKIHELPER_NAMESPACE_RESERVED_NAME_2,
                     master['pki_instance_name'],
                     master['pki_instance_registry_path'],
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
+                raise Exception(log.PKIHELPER_NAMESPACE_RESERVED_NAME_2 % (master['pki_instance_name'],
+                                                                          master['pki_instance_registry_path']))
 
 
 # PKI Deployment Configuration File Class
@@ -428,17 +439,17 @@ class configuration_file:
         #        parameter that may be stored in a log file.
         config.pki_log.info(log.PKI_CONFIGURATION_WIZARD_URL_1,
                             master['pki_configuration_url'],
-                            extra=config.PKI_INDENTATION_LEVEL_2)
+                            extra = config.PKI_INDENTATION_LEVEL_2)
         config.pki_log.info(log.PKI_CONFIGURATION_WIZARD_RESTART_1,
                             master['pki_registry_initscript_command'],
-                            extra=config.PKI_INDENTATION_LEVEL_2)
+                            extra = config.PKI_INDENTATION_LEVEL_2)
 
     def display_configuration_url(self):
         # NOTE:  This is the one and only parameter containing a sensitive
         #        parameter that may be displayed to the screen.
         print log.PKI_CONFIGURATION_URL_1 % master['pki_configuration_url']
         print
-        print log.PKI_CONFIGURATION_RESTART_1 %\
+        print log.PKI_CONFIGURATION_RESTART_1 % \
               master['pki_registry_initscript_command']
         print
 
@@ -452,8 +463,9 @@ class configuration_file:
                     log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
                     "pki_ds_password",
                     master['pki_user_deployment_cfg'],
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
+                raise Exception(log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2 % ("pki_ds_password",
+                                                                                     master['pki_user_deployment_cfg']))
             # Verify existence of Admin Password (except for Clones)
             if not config.str2bool(master['pki_clone']):
                 if not master.has_key('pki_admin_password') or\
@@ -462,8 +474,9 @@ class configuration_file:
                         log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
                         "pki_admin_password",
                         master['pki_user_deployment_cfg'],
-                        extra=config.PKI_INDENTATION_LEVEL_2)
-                    sys.exit(1)
+                        extra = config.PKI_INDENTATION_LEVEL_2)
+                    raise Exception(log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2 % ("pki_admin_password",
+                                                                                         master['pki_user_deployment_cfg']))
             # If required, verify existence of Backup Password
             if config.str2bool(master['pki_backup_keys']):
                 if not master.has_key('pki_backup_password') or\
@@ -472,8 +485,9 @@ class configuration_file:
                         log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
                         "pki_backup_password",
                         master['pki_user_deployment_cfg'],
-                        extra=config.PKI_INDENTATION_LEVEL_2)
-                    sys.exit(1)
+                        extra = config.PKI_INDENTATION_LEVEL_2)
+                    raise Exception(log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2 % ("pki_backup_password",
+                                                                                         master['pki_user_deployment_cfg']))
             # Verify existence of Client Pin for NSS client security databases
             if not master.has_key('pki_client_database_password') or\
                not len(master['pki_client_database_password']):
@@ -481,8 +495,9 @@ class configuration_file:
                     log.PKIHELPER_UNDEFINED_CLIENT_DATABASE_PASSWORD_2,
                     "pki_client_database_password",
                     master['pki_user_deployment_cfg'],
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
+                raise Exception(log.PKIHELPER_UNDEFINED_CLIENT_DATABASE_PASSWORD_2 % ("pki_client_database_password",
+                                                                                     master['pki_user_deployment_cfg']))
             # Verify existence of Client PKCS #12 Password for Admin Cert
             if not master.has_key('pki_client_pkcs12_password') or\
                not len(master['pki_client_pkcs12_password']):
@@ -490,8 +505,9 @@ class configuration_file:
                     log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
                     "pki_client_pkcs12_password",
                     master['pki_user_deployment_cfg'],
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
+                raise Exception(log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2 % ("pki_client_pkcs12_password",
+                                                                                     master['pki_user_deployment_cfg']))
             # Verify existence of PKCS #12 Password (ONLY for Clones)
             if config.str2bool(master['pki_clone']):
                 if not master.has_key('pki_clone_pkcs12_password') or\
@@ -500,8 +516,9 @@ class configuration_file:
                         log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
                         "pki_clone_pkcs12_password",
                         master['pki_user_deployment_cfg'],
-                        extra=config.PKI_INDENTATION_LEVEL_2)
-                    sys.exit(1)
+                        extra = config.PKI_INDENTATION_LEVEL_2)
+                    raise Exception(log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2 % ("pki_clone_pkcs12_password",
+                                                                                         master['pki_user_deployment_cfg']))
             # Verify existence of Security Domain Password File
             # (ONLY for Clones, KRA, OCSP, TKS, or Subordinate CA)
             if config.str2bool(master['pki_clone']) or\
@@ -513,8 +530,9 @@ class configuration_file:
                         log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
                         "pki_security_domain_password",
                         master['pki_user_deployment_cfg'],
-                        extra=config.PKI_INDENTATION_LEVEL_2)
-                    sys.exit(1)
+                        extra = config.PKI_INDENTATION_LEVEL_2)
+                    raise Exception(log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2 % ("pki_security_domain_password",
+                                                                                          master['pki_user_deployment_cfg']))
             # If required, verify existence of Token Password
             if not master['pki_token_name'] == "internal":
                 if not master.has_key('pki_token_password') or\
@@ -523,8 +541,9 @@ class configuration_file:
                         log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
                         "pki_token_password",
                         master['pki_user_deployment_cfg'],
-                        extra=config.PKI_INDENTATION_LEVEL_2)
-                    sys.exit(1)
+                        extra = config.PKI_INDENTATION_LEVEL_2)
+                    raise Exception(log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2 % ("pki_token_password",
+                                                                                         master['pki_user_deployment_cfg']))
         return
 
     def verify_mutually_exclusive_data(self):
@@ -537,29 +556,29 @@ class configuration_file:
                     config.pki_log.error(
                         log.PKIHELPER_MUTUALLY_EXCLUSIVE_CLONE_EXTERNAL_SUB_CA,
                         master['pki_user_deployment_cfg'],
-                        extra=config.PKI_INDENTATION_LEVEL_2)
-                    sys.exit(1)
+                        extra = config.PKI_INDENTATION_LEVEL_2)
+                    raise Exception(log.PKIHELPER_MUTUALLY_EXCLUSIVE_CLONE_EXTERNAL_SUB_CA % master['pki_user_deployment_cfg'])
                 elif config.str2bool(master['pki_clone']) and\
                      config.str2bool(master['pki_external']):
                     config.pki_log.error(
                         log.PKIHELPER_MUTUALLY_EXCLUSIVE_CLONE_EXTERNAL_CA,
                         master['pki_user_deployment_cfg'],
-                        extra=config.PKI_INDENTATION_LEVEL_2)
-                    sys.exit(1)
+                        extra = config.PKI_INDENTATION_LEVEL_2)
+                    raise Exception(log.PKIHELPER_MUTUALLY_EXCLUSIVE_CLONE_EXTERNAL_CA % master['pki_user_deployment_cfg'])
                 elif config.str2bool(master['pki_clone']) and\
                      config.str2bool(master['pki_subordinate']):
                     config.pki_log.error(
                         log.PKIHELPER_MUTUALLY_EXCLUSIVE_CLONE_SUB_CA,
                         master['pki_user_deployment_cfg'],
-                        extra=config.PKI_INDENTATION_LEVEL_2)
-                    sys.exit(1)
+                        extra = config.PKI_INDENTATION_LEVEL_2)
+                    raise Exception(log.PKIHELPER_MUTUALLY_EXCLUSIVE_CLONE_SUB_CA % master['pki_user_deployment_cfg'])
                 elif config.str2bool(master['pki_external']) and\
                      config.str2bool(master['pki_subordinate']):
                     config.pki_log.error(
                         log.PKIHELPER_MUTUALLY_EXCLUSIVE_EXTERNAL_SUB_CA,
                         master['pki_user_deployment_cfg'],
-                        extra=config.PKI_INDENTATION_LEVEL_2)
-                    sys.exit(1)
+                        extra = config.PKI_INDENTATION_LEVEL_2)
+                    raise Exception(log.PKIHELPER_MUTUALLY_EXCLUSIVE_EXTERNAL_SUB_CA % master['pki_user_deployment_cfg'])
 
     def verify_predefined_configuration_file_data(self):
         # Silently verify the existence of any required 'predefined' data
